#require "findLoops/version"
require 'csv'

class FindLoops
  attr_accessor :commandPath, :extractPath, :inputFile, :outputFile, :progressFile, :finding, :doneFinding, :gifProgress

  def initialize(commandLoop,extractFrames, input, output, progress)
  	@commandPath = commandLoop
    @extractPath = extractFrames
  	@inputFile = input
  	@outputFile = output
  	@progressFile = progress
    @finding = false
    @doneFinding = false
  end
  
  def find
  	command = @commandPath << " "
  	command << "-i \"" << @inputFile << "\" "
  	command << "-o \"" << @outputFile << "\" "
  	command << "-p \"" << @progressFile << "\" "
    #command << "&"
  	command << "> /dev/null &"
  	pid = spawn(command)
  	Process.detach(pid)
    @finding = true
  end

  def getFindProgress
    if @finding
      text = File.open(@progressFile, "r").read
      lines = text.lines.to_a
      if lines.size > 1
        line = lines[-1]
        percIdx = line.index("%")
        if percIdx != nil
          percentDone = line.slice(0,percIdx);
          if percentDone == "100"
            @doneFinding = true
            @finding = false
          end
          return percentDone.to_f
        end
      end
    elsif @doneFinding
      return 100
    elsif !@finding
      return 0
    end
  end

  def deleteFindProgress
    self.getFindProgress
    if @doneFinding
      #File.close(@progressFile)
      File.delete(@progressFile)
    end
  end

  def numGifs
    self.getFindProgress
    if @doneFinding
      numGifs = File.open(@outputFile).readlines.size
      #File.close(@outputFile)
      return numGifs
    end
  end

  def getGifs(imagePrefix, gifPrefix)
  	CSV.foreach(@outputFile) do |row|
      imPrefixFinal = String.new(imagePrefix)
      imPrefixFinal << "#{$.}_"
      command1 = String.new
      command1 << "getGifs "
      command1 << "-i \"" << @inputFile << "\" "
      command1 << "-s " << row[0] << " -e " << row[1] << " "
      command1 << "-o \"" << imPrefixFinal << "\" "
      command1 << "-g \"" << gifPrefix << "#{$.}\""
      pid = spawn (command1)
      Process.detach(pid)
    end
    File.delete(@outputFile)
  end
end
